class TransMatrix{
  
//Attribute
private int s, t;
private int k, l;
private int P;
private int m;
private int xA, yA, xN, yN;
private int[][] matrix;
private int N ;//Bildbreite;
private color farbe;
private PImage bild,neuesBild,tempBild;
private int xAlt,yAlt,xNeu,yNeu;
private int periodeMax = 2000;
private boolean istGleich;

 


//Konstruktor
 public TransMatrix(int s, int t, PImage bild, int l, int N){
   this.s =s;
   this.t =t;
   this.bild =bild;
   this.l =l;
   this.N =N;
   m = 0;
   matrix = new int[2][2];
   matrix[0][0]=1+s*t;
   matrix[0][1]=s;
   matrix[1][0]=t;
   matrix[1][1]=1; 
   neuesBild = new PImage(N,N); 
   tempBild = new PImage(N,N); 
   k=0;
 }


//Methoden
  
PImage catMappen(){

  //über alle Pixel iterieren
  for (int j = 0; j < N; j++) {
   for (int i = 0; i < N; i++) {  
     farbe = bild.get(i,j);
     xAlt = i; yAlt = j;
      while (k<l) {    
          xNeu= (matrix[0][0]*xAlt+matrix[0][1]*yAlt)%N;
          yNeu= (matrix[1][0]*xAlt + matrix[1][1]*yAlt)%N;      
          xAlt= xNeu; yAlt= yNeu;   
          k++;
     } 
     k=0;
     neuesBild.set(xAlt,yAlt,farbe);   
    
   }
 } 

  return neuesBild; 
}  

  
int periodeBestimmen(PImage bild){
  
  for (int j = 0; j < N; j++) {
    for (int i = 0; i < N; i++) { 
       farbe = bild.get(i,j);
       tempBild.set(i,j,farbe) ;
    }
  }
 
  for(int m=1; m<periodeMax; m++){ 
   for (int j = 0; j < N; j++) {
     for (int i = 0; i < N; i++) {  
     farbe = tempBild.get(i,j); 
     xAlt = i; yAlt = j;
    
     xNeu =xAbbilden(xAlt,yAlt); 
     yNeu =yAbbilden(xAlt,yAlt);
     xAlt = xNeu; yAlt = yNeu;
     neuesBild.set(xAlt,yAlt,farbe);   
         
     }
    }
    if(gleichheit(bild, neuesBild)){
        P =m;
        m=periodeMax;   
    } else{
       for (int j = 0; j < N; j++) {
         for (int i = 0; i < N; i++) { 
           farbe = neuesBild.get(i,j);
           tempBild.set(i,j,farbe) ;
         }
       }
    }
}
  
  return P;
}
  
int xAbbilden(int xA, int yA){
  xN= (matrix[0][0]*xA+matrix[0][1]*yA)%N;
  return xN;
}

int yAbbilden(int xA, int yA){
  yN= (matrix[1][0]*xA+matrix[1][1]*yA)%N;
  return yN;
}
  
boolean gleichheit(PImage original, PImage abgebildet){//Überprüfung der Gleichheit von Anfangsbild und CatMap-Bild

 istGleich = true;
  for(int c =0; c<600; c++){//Eine Zeile und eine Spalte zu überprüfen, reicht.
     istGleich = (abgebildet.get(c,5)== original.get(c,5)) && istGleich; //beliebige Zeile gleich
     istGleich = (abgebildet.get(7,c)== original.get(7,c)) && istGleich; //beliebige Spalte gleich
   }    
  return istGleich; 
}  
  

  
  
  
  
  
  
}